Lib.TutorialObjects = (function() {
    var obj = {};
    var repo = Lib.createRepo();

    function TextPopup(opts) {
        var self = this;
        var opts = opts || {};

        var x = Lib.check.isNumber(opts.x) ? opts.x : 100;
        var y = Lib.check.isNumber(opts.y) ? opts.y : 100;
        var paddingX = Lib.check.isNumber(opts.paddingX) ? opts.paddingX : 30;
        var paddingY = Lib.check.isNumber(opts.paddingY) ? opts.paddingY : 30;
        var text = Lib.check.totalStringCheck(opts.text, "Lorem ipsum dolor sit amet,\n consectetur adipiscintur?\n\nSi longus, levis;");
        var style = Lib.check.isObject(opts.style) ? opts.style : {
            font: "10px Arial",
            fill: "#ffffff",
            align: "center"
        };
        var maxWidth = Lib.check.isNumber(opts.maxWidth) ? opts.maxWidth : 100;
        var rectangleColor = Lib.check.isNumber(opts.rectangleColor) ? opts.rectangleColor : 0xcdcdcd;
        var rectangleAlpha = Lib.check.isNumber(opts.rectangleAlpha) ? opts.rectangleAlpha : 1;
        var rectangleRadius = Lib.check.isNumber(opts.rectangleRadius) ? opts.rectangleRadius : 50;
        var textAlpha = Lib.check.isNumber(opts.textAlpha) ? opts.textAlpha : 1;
        //0 width == no stroke. 
        var strokeWidth = Lib.check.isNumber(opts.strokeWidth) ? opts.strokeWidth : 1;
        var strokeColor = Lib.check.isNumber(opts.strokeColor) ? opts.strokeColor : 0x000;
        var strokeAlpha = Lib.check.isNumber(opts.strokeAlpha) ? opts.strokeAlpha : 1;


        //----------------------------
        var yTravelDistance = -30;

        var startX = x;
        var startY = y+yTravelDistance;

        var textInRoundedRect = new TextInRoundedRect({
            strokeWidth: strokeWidth,
            strokeColor:strokeColor,
            strokeAlpha:strokeAlpha,
            maxWidth: maxWidth,
            rectangleColor: rectangleColor,
            rectangelRadius:rectangleRadius,
            rectangleAlpha: rectangleAlpha,
            textAlpha: textAlpha,
            text: text,
            style: style,
            x: startX,
            y: startY,
            paddingX: paddingX,
            paddingY: paddingY
        });

        var inertiaTweenData = [10, -5, 0];
        var offsetMultiplier = 1;
        var inverseSpeed = 0.2;

        Lib.animFx.travelTo({
            x: x - paddingX,
            y: y - paddingY,
            inverseSpeed: inverseSpeed,
            type: Lib.DEFS.ANIM_FX.TRAVEL_TO.INERTIA,
            inertiaTweenData: inertiaTweenData,
            offsetMultiplier: offsetMultiplier,
            obj: textInRoundedRect.rectangleObj
        });

        Lib.animFx.travelTo({
            x: x,
            y: y,
            inverseSpeed: inverseSpeed,
            type: Lib.DEFS.ANIM_FX.TRAVEL_TO.INERTIA,
            inertiaTweenData: inertiaTweenData,
            offsetMultiplier: offsetMultiplier,
            obj: textInRoundedRect.textObj
        });

        this.destroy = function() {
            _goUpAndDisappear();
        }


        function _goUpAndDisappearSelfDestroy() {
            p('Called');
            var textTween = game.add.tween(textInRoundedRect.textObj);
            var rectangleTween = game.add.tween(textInRoundedRect.rectangleObj);
            textTween.to({
                x: x,
                y: y + yTravelDistance,
                alpha: 0,
            }, Lib.DEFS.SECOND * inverseSpeed, Phaser.Easing.Quadratic.Out);

            rectangleTween.to({
                x: x - paddingX,
                y: y - paddingY + yTravelDistance,
                alpha: 0,
            }, Lib.DEFS.SECOND * inverseSpeed, Phaser.Easing.Quadratic.Out);



            textTween.start();
            rectangleTween.start();

            textTween.onComplete.add(_destroy,this);

            function _destroy () {
                textInRoundedRect.destroy();
            }
        }




        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    _goUpAndDisappearSelfDestroy();
                    self.destroyWasCalled = true;
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }
    }

    obj.TextPopup = TextPopup;

    //generic text in a rounded rectangle
    function TextInRoundedRect(opts) {
        var self = this;
        var opts = opts || {};
        var x = Lib.check.isNumber(opts.x) ? opts.x : 100;
        var y = Lib.check.isNumber(opts.y) ? opts.y : 100;
        var paddingX = Lib.check.isNumber(opts.paddingX) ? opts.paddingX : 30;
        var paddingY = Lib.check.isNumber(opts.paddingY) ? opts.paddingY : 30;
        var text = Lib.check.totalStringCheck(opts.text, "Lorem ipsum dolor sit amet,\n consectetur adipiscing elit. Quid ergo aliud intellegetur nisi uti ne quae pars naturae neglegatur?\n\nSi longus, levis;");
        var style = Lib.check.isObject(opts.style) ? opts.style : {
            font: "10px Arial",
            fill: "#ffffff",
            align: "center"
        };
        var maxWidth = Lib.check.isNumber(opts.maxWidth) ? opts.maxWidth : 100;
        var rectangleColor = Lib.check.isNumber(opts.rectangleColor) ? opts.rectangleColor : 0xcdcdcd;
        var rectangleAlpha = Lib.check.isNumber(opts.rectangleAlpha) ? opts.rectangleAlpha : 1;
        var rectangleRadius = Lib.check.isNumber(opts.rectangleRadius) ? opts.rectangleRadius : 50;
        var textAlpha = Lib.check.isNumber(opts.textAlpha) ? opts.textAlpha : 1;
        //0 width == no stroke. 
        var strokeWidth = Lib.check.isNumber(opts.strokeWidth) ? opts.strokeWidth : 1;
        var strokeColor = Lib.check.isNumber(opts.strokeColor) ? opts.strokeColor : 0x000;
        var strokeAlpha = Lib.check.isNumber(opts.strokeAlpha) ? opts.strokeAlpha : 1;

        //LOCAL VARS---------------------------------
        var rectangleGroup = game.add.group();
        rectangleGroup.classType = Phaser.Image;

        var textGroup = game.add.group();
        textGroup.classType = Phaser.Image;
        //------------------------------------------

        //Create text
        var textTemp = game.add.text(x, y, text, style, textGroup);
        textTemp.wordWrap = true;
        textTemp.wordWrapWidth = maxWidth;
        //convert it into a texture and delete initial editable text object
        var textTexture = textTemp.generateTexture()
        this.textObj = textGroup.create(x, y, textTexture);
        this.textObj.alpha = textAlpha;
        textTemp.destroy();

        //create rounder rect
        var rectangleTexture = Lib.Draw.getTex_RoundedRect({
            color: rectangleColor,
            width: this.textObj.width + paddingX * 2,
            height: this.textObj.height + paddingY * 2,
            radius: rectangleRadius,
            lineWidth: strokeWidth,
            lineColor: strokeColor,
            lineAlpha: strokeAlpha
        });
        this.rectangleObj = rectangleGroup.create(this.textObj.x - paddingX, this.textObj.y - paddingY, rectangleTexture);
        this.rectangleObj.alpha = rectangleAlpha;


        // STANDARD REPO CODE - ----------------------------------------
        repo.addObj(this);
        this.destroyWasCalled = false;
        //REQUIRED-----------------
        this.destroy = function() {
                if (!self.destroyWasCalled) {
                    // p("Destroy is called '");
                    repo.removeObj(self);
                    self.rectangleObj.destroy();
                    self.textObj.destroy();
                    self.destroyWasCalled = true;
                }
            }
            //OPTIONAL--------------------

        this._update = function() {
            // p("Im a BOx Emitter");
        }
    }

    obj.TextInRoundedRect = TextInRoundedRect

    //------
    return obj;
}());


//###############################
//Dynamic drawing---------------

Lib.Draw = (function(){
    var obj = {};

    function getTex_RoundedRect(opts){
        var self = this;
        var opts = opts || {};
        var color = Lib.check.isNumber(opts.color) ? opts.color : 0xffffff;
        var lineWidth = Lib.check.isNumber(opts.lineWidth) ? opts.lineWidth : 0;
        var lineColor = Lib.check.isNumber(opts.lineColor) ? opts.lineColor : 0x000000;
        var lineAlpha = Lib.check.isNumber(opts.lineAlpha) ? opts.lineAlpha : 1;
        var width = Lib.check.isNumber(opts.width) ? opts.width : 200;
        var height = Lib.check.isNumber(opts.height) ? opts.height : 100;
        var radius = Lib.check.isNumber(opts.radius) ? opts.radius : 60;

        var graphics = game.add.graphics(0,0);

        graphics.beginFill(color);
        graphics.lineStyle(lineWidth,lineColor,lineAlpha);
        graphics.drawRoundedRect(0,0,width,height,radius);
        graphics.endFill();

        var texture = graphics.generateTexture();
        graphics.destroy();

        return texture;
    }

    obj.getTex_RoundedRect = getTex_RoundedRect;

    //
    return obj;

}());